/*globals define*/

define([
    'testsuite/qunit',
    'jquery', 'ep/modify',

    'jquery/metaparse',
    'ep/ui/validate',
    '$ready!'
], function (QUnit, $, ep) {
    'use strict';

    QUnit.module("ep.modify", {
        setup: function () {
            $('#qunit-fixture').append('<input type="text" class="ep-js" data-js=".uiValidate({required:true})"/>'
                + '<input type="text" class="ep-js" data-js=".uiValidate({required:true})"/>'
                + '<input type="text" class="ep-js" data-js=".uiValidate({required:true})"/>');
        }
    });

    QUnit.test("ep.modify", function () {

        var tValue;

        // run metaparse
        $('.ep-js').metaparse();
        // bind changeAttr
        $('div').on('changeAttr', function (event, attr) {
            tValue = attr;
        });

        $('div').attr({
            'class': 'TEST'
        });
        QUnit.deepEqual(
            tValue,
            {'class': 'TEST'},
            "$('div').attr({'class':'TEST'})"
        );

        $('div').removeAttr('class');
        QUnit.deepEqual(
            tValue,
            {'class': null},
            "$('div').removeAttr('class')"
        );

        $('div').attr('class', 'NEU');
        QUnit.deepEqual(
            tValue,
            {'class': 'NEU'},
            "$('div').attr('class','TEST')"
        );

        QUnit.equal(
            $(':input:invalid').length,
            0,
            "$(':input:invalid').length"
        );

        QUnit.equal(
            $(':input').trigger('validate').filter(':invalid').length,
            3,
            "$(':input').trigger('validate').filter(':invalid').length"
        );
    });

});